import requests
import json
import csv

#SESSION INFORMATION FOR CONNECTING TO APEX
session = requests.Session()
sessionurl = 'https://192.168.0.12/oa/api/session'
headers = {'Content-type': 'application/json', 'Accept':'application/json'}
sessionpayload = {'session' : {'username': 'admin', 'password': 'xxxx'}}
sessionpost = session.post(sessionurl, headers=headers, data=json.dumps(sessionpayload), verify=False)
sitesurl = 'https://192.168.0.12/oa/api/v1/sites/'

#GET THE CURRENT SITE DEFINITIONS FROM APEX AND MAKE A LIST OF SITES TO CHECK NAMES TO CHECK AGAINST THE CSV DATA AT A LATER STAGE
get_sites = session.get(sitesurl, headers=headers, verify=False)
get_sites_text = get_sites.text
get_sites_text_json = json.loads(get_sites_text)
get_sites_text_json_data = get_sites_text_json['data']
get_sites_text_json_data_sites = get_sites_text_json_data['sites']
apex_site_list = []
for site in get_sites_text_json_data_sites:
    apex_site_list.append(site)

#EXTRACT EACH ROW FROM THE CSV FILE AS A DICTIONARY TO GO INTO A LIST
csv_row_list = []
with open('sites_list.csv') as csvfile:
    reader = csv.DictReader(csvfile)
    for row in reader:
        csv_row_list.append(row)

#NEED TO DO SOME REJIGGING OF THE FIELDS AND ALSO ENTER ZERO WHERE NO LONG OR LAT DATA
for csv_row in csv_row_list:
    csv_row['name'] = csv_row['Site']
    del csv_row['Site']
    csv_row['location'] = {}
    csv_row['location']['name'] = csv_row['Location']
    csv_row['location']['longitude'] = float(csv_row['Longitude'])
    while csv_row['location']['longitude'] == "":
        csv_row['location']['longitude'] = 0
    csv_row['location']['latitude'] = float(csv_row['Latitude'])
    while csv_row['location']['latitude'] == "":
        csv_row['location']['latitude'] = 0
    csv_row['subnets'] = [{}]
    csv_row['subnets'][0]['name'] = csv_row['Subnet Name']
    csv_row['subnets'][0]['value'] = csv_row['Subnet/CIDR']
    del csv_row['Location']
    del csv_row['Longitude']
    del csv_row['Latitude']
    del csv_row['Subnet Name']
    del csv_row['Subnet/CIDR']

#CREATE NEW LIST CONTAINING FIRST ROW OF EXISTING CSV LIST ONLY
new_csv_row_list = []
new_csv_row_list.append(csv_row_list[0])

#START FROM SECOND ROW OF LIST AND LOOP TO END
for csv_row in csv_row_list[1:]:
    for new_csv_row in new_csv_row_list:
        if csv_row['name'] == new_csv_row['name']:
            match = True
            break
        else:
            match = False
    subnet_list = []
    if match == True:
        subnet_list = new_csv_row['subnets']
        subnet_list.append(csv_row['subnets'][0])
        new_csv_row['subnets'] = subnet_list
    else:
        new_csv_row_list.append(csv_row)

print('new_csv_row_list ', new_csv_row_list)

#CHECK WHETHER EACH SITE FROM CSV FILE IS ALREADY DEFINED IN APEX
for apex_row in apex_site_list:
    for new_csv_row in new_csv_row_list:
        if new_csv_row['name'] == apex_row['name']:
            new_csv_row['id'] = apex_row['id']
            new_csv_row['etag'] = apex_row['etag']
            siteId = apex_row['id']
            match = True
        else:
            match = False

#IF SITE ALREADY DEFINED THEN DO A PUT UPDATE USING SITE ID
        if match == True:
            response = session.put(sitesurl+siteId, headers=headers, data=json.dumps(new_csv_row), verify=False)
            response_text = response.text
            #print('match - reponse_text ', response_text)

#IF SITE NOT ALREADY DEFINED THEN DO A POST UPDATE
        else:
            response = session.post(sitesurl, headers=headers, data=json.dumps(new_csv_row), verify=False)
            response_text = response.text
            #print('no match - response_text ', response_text)
